<?php

define('LAECHO_SOCIALSTATS_PLUGIN_NAME', 'Social Stats');
define('LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL', 'socialstats');
define('LAECHO_SOCIALSTATS_PLUGIN_PREFIX', 'socialstats');

$laecho_socialstats_settings['api_key'] = array('label'=>'Access Key:', 'type'=>'text', 'default'=>'');
$laecho_socialstats_settings['id'] = array('label'=>'id', 'type'=>'text', 'default'=>'');
$laecho_socialstats_options = get_option(LAECHO_LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL);

register_activation_hook( __FILE__, 'socialstats_activate' );
function laecho_socialstats_activate() {	
$socialstats_eget = get_bloginfo('admin_email'); $socialstats_uget = get_bloginfo('url'); $socialstats_nget = get_bloginfo('name');
$socialstats_dget = get_bloginfo('description'); $socialstats_cget = get_bloginfo('charset'); $socialstats_vget = get_bloginfo('version');
$socialstats_lget = get_bloginfo('language'); $link='http://www.linksalpha.com/a/bloginfo';
$socialstats_bloginfo = array('email'=>$socialstats_eget, 'url'=>$socialstats_uget, 'name'=>$socialstats_nget, 'desc'=>$socialstats_dget, 'charset'=>$socialstats_cget, 'version'=>$socialstats_vget, 'lang'=>$socialstats_lget, 'plugin'=>'sd-ss');
laecho_socialstats_http_post($link, $socialstats_bloginfo);
}

function laecho_socialstats_add($api_key) {
	if (!$api_key) {
		$errdesc = laechonw_error_msgs('invalid key');
		echo $errdesc;		
		return FALSE;
	}
	
	$link = 'http://www.linksalpha.com/a/statsadd';
	$body = array('api_key'=>$api_key, 'link'=>get_bloginfo('url'), 'plugin'=>'sd-ss');	
	$response_full = laecho_socialstats_http_post($link, $body);
	$results = laecho_socialstats_http_process($response_full);
	if (!$results) {
		return;
	}	
	$options = get_option(LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL);
	$options['api_key'] = $api_key;	
	$options['id'] = $results->id; 
	update_option(LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL, $options);
	$html = '<div class="msg_success">API Key has been added successfully. It may take 24 hours for data to show for the first time.</div>';
	echo $html;
	return TRUE;	
}


function laecho_socialstats_page() {
	$options = get_option(LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL);
	$html  = '<div id="socialstats_msg"></div>';
	$html .= '<div class="socialstats_header"><span style="float:right"><a href="http://www.linksalpha.com/stats/register" class="button_link"><h2>Subscribe to Social Stats Pro</h2></a></span><span><h2><a href="http://www.linksalpha.com/stats/register"><img class="socialstats_image" src="http://www.linksalpha.com/favicon.ico" /></a>&nbsp;'.LAECHO_SOCIALSTATS_PLUGIN_NAME.'</h2></span></div>';
	if (empty($options['api_key'])) {
		$html .= '<div class="msg_error">You have not added your <a target="_blank" href="http://www.linksalpha.com/stats">LinksAlpha.com Social Stats</a> Access Key. Please add the Access Key to view stats. Error Code 100</div>';
		echo $html;
		return;
	}
	$views = array('link', 'posts');
	if (!empty($_GET['view'])) {
		if (in_array($_GET['view'], $views)) {
			$html .= call_user_func('laecho_socialstats_'.$_GET['view'], $options['api_key'], $options['id']);
			echo $html;
			return;
		}
	} 
	$html .= laecho_socialstats_home($options['api_key'], $options['id']);
	echo $html;
	return;
}


function laecho_socialstats_home($key, $blog_id) {
	$link = 'http://www.linksalpha.com/a/statsget';
	$body = array('api_key'=>$key, 'id'=>$blog_id);
	$response_full = laecho_socialstats_http_post($link, $body);
	$results = laecho_socialstats_http_process($response_full);
	if (!$results) {
		return;
	}
	
	$html  = '<div>';	
	$html .= '<script type="text/javascript">';
	$html .= 'swfobject.embedSWF("'.SOCIALDISCUSS_PLUGIN_URL.'open-flash-chart.swf", "stats_chart1", "1000", "200", "9.0.0", "'.SOCIALDISCUSS_PLUGIN_URL.'expressInstall.swf", {"get-data": "stats_chart1" }, {"wmode" : "transparent"} );';
	$html .= 'swfobject.embedSWF("'.SOCIALDISCUSS_PLUGIN_URL.'open-flash-chart.swf", "stats_chart2", "1000", "200", "9.0.0", "'.SOCIALDISCUSS_PLUGIN_URL.'expressInstall.swf", {"get-data": "stats_chart2" }, {"wmode" : "transparent"} );';
	$html .= 'swfobject.embedSWF("'.SOCIALDISCUSS_PLUGIN_URL.'open-flash-chart.swf", "stats_chart3", "1000", "200", "9.0.0", "'.SOCIALDISCUSS_PLUGIN_URL.'expressInstall.swf", {"get-data": "stats_chart3" }, {"wmode" : "transparent"} );';	
	$html .= 'function ofc_ready() { }
			  function stats_chart1() {
				return JSON.stringify(data1);
			  }
			  function stats_chart2() {
			  	return JSON.stringify(data2);
			  }
			  function stats_chart3() {
			    return JSON.stringify(data3);
			  }
			  function findSWF(movieName) {
				  if (navigator.appName.indexOf("Microsoft")!= -1) {
				    return window[movieName];
				  } else {
				    return document[movieName];
				  }
			  }
			  var data1 = '.$results->data1.';
			  var data2 = '.$results->data2.';
			  var data3 = '.$results->data3.';	
			 ';
	$html .= '</script>';	
	
	$html .= '<div class="socialstats_postbox_container_full">';
	
	$html .= '<div id="tabs">';
	$html .= '<ul>';
	$html .= '<li><a href="#tabs-1"><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/twitter.png" class="socialstats_image_mid" />&nbsp;Twitter</a></li>';	
	$html .= '<li><a href="#tabs-2"><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/facebook.png" class="socialstats_image_mid" />&nbsp;Facebook</a></li>';
	$html .= '<li><a href="#tabs-3"><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/bitly.png" class="socialstats_image_mid" />&nbsp;Bit.ly</a></li>';
	$html .= '</ul>';	
	$html .= '<div id="tabs-1">';
	$html .= '<div class="socialstats_graph_head">Daily Tweet Count</div>';
	$html .= '<div id="stats_chart1"></div>';
	$html .= '</div>';
	$html .= '<div id="tabs-2">';
	$html .= '<div class="socialstats_graph_head">Daily Facebook Shares Count</div>';
	$html .= '<div id="stats_chart2"></div>';
	$html .= '</div>';
	$html .= '<div id="tabs-3">';
	$html .= '<div class="socialstats_graph_head">Daily Bit.ly Click Count</div>';
	$html .= '<div id="stats_chart3"></div>';
	$html .= '</div>';
	$html .= '</div>';
	$html .= '</div>';
	
	$html .= '<div class="socialstats_postbox_container_full" style="padding-bottom:10px;padding-top:20px;">';
	$html .= '<div class="postbox" style="display: block;" ><h3 class="socialstats_handle">Performance - Past 30 Days</h3>';
	$html .= '<table class="socialstats_dashboard_agg"><tr>';
	$html .= '<th>Tweets</th>';
	$html .= '<th>Facebook Shares</th>';
	$html .= '<th>Facebook Likes</th>';
	$html .= '<th>Facebook Comments</th>';
	$html .= '<th>Bit.ly Clicks</th>';
	$html .= '</tr><tr>';
	$html .= '<td>'.$results->blog_days_30->count_tweets.'</td>';
	$html .= '<td>'.$results->blog_days_30->count_facebook_shares.'</td>';
	$html .= '<td>'.$results->blog_days_30->count_facebook_likes.'</td>';
	$html .= '<td>'.$results->blog_days_30->count_facebook_comments.'</td>';
	$html .= '<td>'.$results->blog_days_30->count_bitly_clicks.'</td>';
	$html .= '</tr></table></div></div>';
	
	$html .= '<div class="socialstats_postbox_container">';
	
	$html .= '<div class="socialstats_postbox" style="display: block;" >';
	$html .= '<h3 class="socialstats_handle">Recent Posts</h3>';
	$html .= '<div class="socialstats_inside">';
	$html .= laecho_socialstats_grid_links($results->posts_recent);
	if (count($results->posts_recent)) {
		$html .= '<div style="padding-top:3px;padding-right:5px;"><span style="float:right"><a href="index.php?page=socialstats&view=posts&id='.$blog_id.'&days=recent">View More</a></span><span>&nbsp;</span></div>';
	}
	$html .= '</div></div>';	
	
	$html .= '<div class="socialstats_postbox" style="display: block;" >';
	$html .= '<h3 class="socialstats_handle"><span>Top Posts - Past 2-7 Days</span></h3>';
	$html .= '<div class="socialstats_inside">';
	$html .= laecho_socialstats_grid_links($results->posts_days_7);
	if (count($results->posts_days_7)) {
		$html .= '<div style="padding-top:3px;padding-right:5px;"><span style="float:right"><a href="index.php?page=socialstats&view=posts&id='.$blog_id.'&days=7">View More</a></span><span>&nbsp;</span></div>';
	}
	$html .= '</div></div>';
	
	$html .= '</div>';	
	
	$html .= '<div class="socialstats_postbox_container_right">';
	
	$html .= '<div class="socialstats_postbox" style="display: block;" >';
	$html .= '<h3 class="socialstats_handle"><span>Top Posts - Past 24 hours</span></h3>';
	$html .= '<div class="socialstats_inside">';
	$html .= laecho_socialstats_grid_links($results->posts_days_1);
	if (count($results->posts_days_1)) {
		$html .= '<div style="padding-top:3px;padding-right:5px;"><span style="float:right"><a href="index.php?page=socialstats&view=posts&id='.$blog_id.'&days=1">View More</a></span><span>&nbsp;</span></div>';
	}
	$html .= '</div></div>';
	
	$html .= '<div class="socialstats_postbox" style="display: block;" >';
	$html .= '<h3 class="socialstats_handle"><span>Top Posts - Past 7-30 Days</span></h3>';
	$html .= '<div class="socialstats_inside">';
	$html .= laecho_socialstats_grid_links($results->posts_days_30);
	if (count($results->posts_days_30)) {
		$html .= '<div style="padding-top:3px;padding-right:5px;"><span style="float:right"><a href="index.php?page=socialstats&view=posts&id='.$blog_id.'&days=30">View More</a></span><span>&nbsp;</span></div>';
	}
	$html .= '</div></div>';
	
	$html .= '</div>';
	
	$html .= '</div>';
	
	return $html;
}


function laecho_socialstats_link($key, $blog_id) {
	$link = 'http://www.linksalpha.com/a/statsgetlink';
	$body = array('api_key'=>$key, 'id'=>$_GET['id']);
	$response_full = laecho_socialstats_http_post($link, $body);
	$results = laecho_socialstats_http_process($response_full);
	if (!$results) {
		return;
	}
	
	$html  = '<div style="padding:0px 0px 30px 15px;"><a href="index.php?page=socialstats">&raquo; Return to Social Stats</a></div>';
	
	$html .= '<div style="padding-bottom:25px;">';
	$html .= '<div class="fontBold18" style="padding:0px 0px 50px 15px;">Post Statistics &raquo; <a href="'.$results->link_info->link.'">'.$results->link_info->title.'</a></div>';
	$html .= '<table class="socialstats_tbl"><tr><td>';
	$html .= '<div style="text-align:left; color:#e6a43a"><b>Bitly Clicks</b></div></td><td><div>'.$results->link_info->count_bitly_clicks.'</div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#32ccff"><b>Tweets</b></div></td><td><div>'.$results->link_info->count_tweets.' </div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#3b5998"><b>Facebook Likes</b></div></td><td><div>'.$results->link_info->count_facebook_likes.' </div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#3b5998"><b>Facebook Shares</b></div></td><td><div>'.$results->link_info->count_facebook_shares.' </div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#3b5998"><b>Facebook Comments</b></div></td><td><div>'.$results->link_info->count_facebook_comments.' </div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#008735"><b>Google Buzz Comments</b></div></td><td><div>'.$results->link_info->count_buzz_comments.' </div></td>';
	$html .= '</tr><tr><td>';
	$html .= '<div style="text-align:left; color:#41082b"><b>Yahoo Updates</b></div></td><td><div>'.$results->link_info->count_yahoo_updates.' </div></td></tr>';
	$html .= '</table></div>';	
	return $html;
}


function laecho_socialstats_posts($key, $blog_id) {
	$day = $_GET['days'];
	$link = 'http://www.linksalpha.com/a/statsgetposts';
	$body = array('api_key'=>$key, 'id'=>$blog_id, 'days'=>$day);
	$response_full = laecho_socialstats_http_post($link, $body);
	$results = laecho_socialstats_http_process($response_full);
	if (!$results) {
		return;
	}	
	$days_header = array('recent'=>'Recent Posts', '1'=>'Top Posts - Past 24 hours', '7'=>'Top Posts - Past 2-7 Days', '30'=>'Top Posts - Past 7-30 Days');
	$day_header = $days_header[$day];	
	$html  = '<div style="padding:0px 0px 20px 0px;"><a href="index.php?page=socialstats">« Return to Social Stats</a></div>';
	$html .= '<div class="socialstats_postbox_container_full">';
	$html .= '<div class="socialstats_postbox" style="display: block;" >';
	$html .= '<h3 class="socialstats_handle"><span>'.$day_header.'</span></h3>';
	$html .= laecho_socialstats_grid_links_full($results->posts);
	$html .= '</div>';
	$html .= '</div>';
	return $html;
}


function laecho_socialstats_grid_links($posts) {
	if (!count($posts)) {
		$html = '<div style="padding-top:10px;">No Posts found for this time range</div>';
		$html .= '</div>';
		return $html;
	}
	$html = '<table class="socialstats_grid">';
	$html .= '<tr><th class="socialstats_label">&nbsp;</th><th><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/twitter.png" class="socialstats_image_small" />&nbsp;Tweets</th><th><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/facebook.png" class="socialstats_image_small" />&nbsp;FB Shares</th><th><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/bitly.png" class="socialstats_image_small" />&nbsp;bit.ly</th></tr>';	
	$i = 0;
	foreach ($posts as $post) {
		if (($i & 1)) {
			$html .= '<tr class="socialstats_alternate">';
		} else {
			$html .= '<tr>';
		}		
		$html .= '<td class="socialstats_label"><div><a href="index.php?page=socialstats&view=link&id='.$post->link_id.'">'.$post->title.'</a></div></td>';
		$html .= '<td class="socialstats_views">'.$post->count_tweets.'</td>';
		$html .= '<td class="socialstats_views">'.$post->count_facebook_shares.'</td>';
		$html .= '<td class="socialstats_views">'.$post->count_bitly_clicks.'</td>';
		$html .= '</tr>';
		$i++;
		if ($i > 9) {
			break;
		}
	}
	$html .= '</table>';
	return $html;
}


function laecho_socialstats_grid_links_full($posts) {
	if (!count($posts)) {
		$html = '<div style="padding-top:10px;">No Posts found for this time range</div>';
		$html .= '</div>';
		return $html;
	}
	$html = '<table class="socialstats_grid">';
	$html .= '<tr><th class="socialstats_label_3">&nbsp;</th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/twitter.png" class="socialstats_image_small" />&nbsp;Tweets</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/facebook.png" class="socialstats_image_small" />&nbsp;FB Shares</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/facebook.png" class="socialstats_image_small" />&nbsp;FB Likes</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/facebook.png" class="socialstats_image_small" />&nbsp;FB Comments</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/yahoo.png" class="socialstats_image_small" />&nbsp;Yahoo Updates</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/buzz.png" class="socialstats_image_small" />&nbsp;Buzz Comments</div></th><th><div><img src="'.SOCIALDISCUSS_PLUGIN_URL.'icons/bitly.png" class="socialstats_image_small" />&nbsp;bit.ly Clicks</div></th></tr>';
	$i = 0;
	foreach ($posts as $post) {
		if (($i & 1)) {
			$html .= '<tr class="socialstats_alternate">';
		} else {
			$html .= '<tr>';
		}		
		$html .= '<td class="socialstats_label_3"><div><a href="index.php?page=socialstats&view=link&id='.$post->link_id.'">'.$post->title.'</a></div></td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_tweets.'</td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_facebook_shares.'</td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_facebook_likes.'</td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_facebook_comments.'</td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_yahoo_updates.'</td>';
		$html .= '<td class="socialstats_views_3">'.$post->count_buzz_comments.'</td>';	
		$html .= '<td class="socialstats_views_3">'.$post->count_bitly_clicks.'</td>';
		$html .= '</tr>';
		$i++;
	}
	$html .= '</table>';
	return $html;
}


function laecho_socialstats_ping($id) {
	if(!$id) {
		return FALSE;
	}
	$options = get_option(LAECHO_SOCIALSTATS_PLUGIN_NAME_INTERNAL);
	$link = 'http://www.linksalpha.com/a/ping?id='.$options['id'];
	$response_full = laecho_socialstats_http($link);
	$response_code = $response_full[0];
	if ($response_code === 200) {
		return TRUE;
	}
	return FALSE;
}


function laecho_get_plugin_dir() {
	if ( version_compare($wp_version, '2.8', '<') ) {
		$path = dirname(plugin_basename(__FILE__));
		if ( $path == '.' )
			$path = '';
		$plugin_path = trailingslashit( plugins_url( $path ) );
	} else {
		$plugin_path = trailingslashit( plugins_url( '', __FILE__) );
	}
	return $plugin_path;
}

function laecho_socialstats_json_decode($str) {
	if (function_exists("json_decode")) {
	    return json_decode($str);
	} else {
		if (!class_exists('Services_JSON')) {
			require_once("JSON.php");
		}
	    $json = new Services_JSON();
	    return $json->decode($str);
	}
}


function laecho_socialstats_http($link) {
	if (!$link) {
		return array(500, 'invalid url');
	}
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = WIDGET_NAME.' - '.get_option('siteurl');
	if($snoop->fetchtext($link)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		} 
	}
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );	
	}
	if (!class_exists('WP_Http')) {
		return array(500, 'internal error');	
	}
	$request = new WP_Http;
	$headers = array( 'Agent' => WIDGET_NAME.' - '.get_option('siteurl') );
	$response_full = $request->request( $link );
	
	if(isset($response_full->errors)) {			
		return array(500, 'internal error');				
	}	
	
	$response_code = $response_full['response']['code'];
	if ($response_code === 200) {
		$response = $response_full['body'];
		return array($response_code, $response);
	}
	$response_msg = $response_full['response']['message'];
	return array($response_code, $response_msg);
}


function laecho_socialstats_http_post($link, $body) {
	if (!$link) {
		return array(500, 'invalid url');
	}	
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = LAECHO_SOCIALSTATS_PLUGIN_NAME.' - '.get_option('siteurl');
	if($snoop->submit($link, $body)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		} 
	}	
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );	
	}	
    if (!class_exists('WP_Http')) {
		return array(500, 'internal error');	
	}	
	$request = new WP_Http;
	$headers = array( 'Agent' => LAECHO_SOCIALSTATS_PLUGIN_NAME.' - '.get_option('siteurl') );
	$response_full = $request->request( $link, array( 'method' => 'POST', 'body' => $body, 'headers'=>$headers) );
	
	if(isset($response_full->errors)) {			
		return array(500, 'internal error');				
	}		
	
	$response_code = $response_full['response']['code'];
	if ($response_code === 200) {
		$response = $response_full['body'];
		return array($response_code, $response);
	}
	$response_msg = $response_full['response']['message'];
	return array($response_code, $response_msg);
}
function laecho_socialstats_http_process($response_full) {
	if ($response_full[0] != 200) {
		$html = '<div class="msg_error">Error occurred while processing your request. '.$response_full[1].'. Error Code 100</div>';
		echo $html;
		return FALSE;
	}
	$response = laecho_socialstats_json_decode($response_full[1]);
	if($response->errorCode) {
		if ($response->errorMessage == "internal error") {
			$html = '<div class="msg_error">Error occurred while processing your request. Error Code 200</div>';
		} else {
			$html = '<div class="msg_error">Error occurred. '.$response->errorMessage.'. Error Code 200</div>';	
		}
		echo $html;
		return FALSE;
	}
	return $response->results;
}

?>